# Definition

The **support** of an itemset ***X *** is the ***proportion*** of transactions which contains it. 
 It is noted <span style="color:#9900FE">**supp(**</span>***X *** <span style="color:#9900FE">**)**</span>.

# Formula

![itemset_support_formula.png](XeFJyAYSgjiN)

# Concept diving

- It can be interpreted as the **likelihood** to purchase the product ***X *** .
- <span style="color:#9900FE">**supp(**</span>***X *** <span style="color:#9900FE">**)**</span> **is in [0, 1]**.


# Regarding our case study

- We have a total of 5 transactions
- The itemset **{<span style="color:#294E14">bacon</span>}** is only recorded in 1 transaction: "t_1".
  - <span style="color:#9900FE">**supp(**</span>**{<span style="color:#294E14">bacon</span> }**<span style="color:#9900FE">**)**</span> = 1/5 = 0.2 .
  - That means that 20 % of transactions contains bacon. In other words, bacon is likely to be purchased 20% of the time.
- The itemset **{<span style="color:#990002">chicken, tomato</span>}** is recorded in 3 transactions: "t_1", "t_2" and "t_5".
  - <span style="color:#9900FE">**supp(**</span>**{<span style="color:#990002">chicken, tomato</span>}**<span style="color:#9900FE">**)**</span> = 3/5 = 0.6 .
  - That means that 60 % of transactions contains <span style="color:#990002">***chicken & tomatoes***</span>. 


![itemsets_support.png](T0t8MAjVqbx8)