# Section presentation

The *Automation* section allows to activate the project automation. By doing this, the project will be able to refresh data automatically over time.

![automation.png](66nbfvDr8qNH)

# Section interactions

To be used, dates filtering strategy should be set to *Keep transactions before and until today* for both "Transactions preprocessing" and "Customers rules recommendations".

**IF** those dates filtering strategies are different from that option, you should not see information above the *ACTIVATE* button, and clicking on that button should lead to a failure and clicking on the *ACTIVATE* button must lead to a scenario failure (see the following picture).

![automation_invalid_dates_filtering_strategies.png](o5rx87Hx9G7L)


**IF** those dates filtering strategies equals that option, you should see the option *Same reference dates for rules learning and recommendation ?* above the *ACTIVATE* button (see the following picture).

This option allows to define if you want to have a time delta between the reference dates taken into account for  the transactions used to learn the association rules and the ones used to recommend items to customers. To get more explanation on this, please read [Reference dates for rules and recommendation](article:70).

In that condition, clicking on the *ACTIVATE* button must lead to a scenario success .

![automation_valid_dates_filtering_strategies.png](s6jr5y9X4DQ3)


Once the scenario succeeded, you can tune the scenario [refresh_flow_over_time](scenario:REFRESH_FLOW_OVER_TIME) so that you define triggers that will refresh all the flow depending on your own business condition.

The picture below showcases what the trigger definition looks like. In this example, the trigger will execute the flow refresh each monday at 01:00 am :

![refresh_flow_over_time.png](ekvvSzv9HtV7)

Many different triggers could be set ([See our official documentation about triggers](https://doc.dataiku.com/dss/latest/scenarios/triggers.html)) to adapt the scenario execution to your business need.