# What if I don't find rules ?

## About the application key parameters
Multiple parameters can have an impact on the quantity of rules found: 

- **The period of time** taken into account in the association rules dates filtering strategy ([More details here](article:50)):
  - For items having an important seasonality or items sold in a short period of time, it will be important to privilege shorter time windows around the items sale cycle to maximize the likelihood to get them involved in association rules (It could thus increase the number of rules found).
 
- **The itemsets minimum frequency** ([More details here](article:51)): The higher the minimum frequency required will be, the less frequent itemets will be found, the less association rules wille be found.

- **The thresholds set to the rule metrics** before validating a rule ([More details here](article:51)): the higher the thresholds set on *confidence*, *lift* and *conviction* will be, the less you will have valid rules. However, be careful while increasing these thresholds, since they might lead to less valuable rules.

- **The minimum number of transactions**: It is set by default to *100* ([More details here](article:51)). That means that any group of transactions having smaller than 100 will be filtered and not taken into account for the association rule learning process.

- **The association rule scope** ([More details here](article:51)): The association rules can help to find new refined rules but it could also lead to loose some rules since the purchasing patterns can vary depending on the scopes we do a focus on. Furthermore, other parameters presented here depend on the association rules scope: 
  - The itemsets minimum frequency: it is computed for each item present in each rule scope. 
  - The minimum number of transactions: it is computed for each group of transaction associated with each rule scope.

## Leveraging the project dashboard
Knowing the key parameters and their impact on the project, you can also leverage [the project's dashboard](article:6) to refine your association rule learning strategy.