# Slide presentation

This slide helps in monitoring the *'number of transactions'* and *'average number of items per transaction'*  involved in the **Market Basket Analysis**. 

:warning: **Diclaimer 1** : These charts are done **AFTER the both the transactions and the items are proprocessed in the [transactions_preprocessing](flow_zone:3La1CrK) zone**, based on the parameters you set in your application (Learn more about [the transactions preprocessing](article:50) or the [association rules computation](article:51)).

:warning: **Diclaimer 2** : On the pictures below, charts have been computed using the "Country" column as an *association rule scope* ([Learn more about this concept](article:51)). Your render will be different (only one time series on *'all_data'* for each graph) if you don't define a rule scope.


![slide_1_overview.png](Xs9HhqEFB6rZ)


# Slide charts

## Number of transactions over time (Left hand side of the dashboard)

These charts shows the evolution of your number of transactions over time, for different time granularities : a daily one, a weekly one and a monthly one.

### Daily number of transactions
![slide_1_daily_number_of_transactions.png](aq9vCycrjpE1)

### Weekly number of transactions
![slide_1_weekly_number_of_transactions.png](BirHnf19cnwO)

### Monthly number of transactions
![slide_1_monthly_number_of_transactions.png](6AeUybz6Ynhw)


## Average number of items per transactions over time (Right hand side of the dashboard)

These charts shows the evolution of your average number of items per transactions over time. Like for the for the previous charts, it is done with daily one, weekly one and monthly one time granularities


### Daily average number of items per transactions
![slide_1_daily_average_number_of_items_per_transactions.png](gRs2shiUKr4Y)

### Weekly average number of items per transactions
![slide_1_weekly_average_number_of_items_per_transactions.png](6pLBx5y6IjYO)

### Monthly average number of items per transactions
![slide_1_monthly_average_number_of_items_per_transactions.png](XARrM4q14GCZ)


# Leveraging these charts

Without the information of the content of each transaction, these charts can help you to : 
- Identify periods where multiple items are purchased together (or, on the contrary, items tend to be rarely purchased together). This could help to see why you find more rules than usual (or, on the contrary, less rules than usual).
- Identify variations of purchasing patterns depending on your rule scopes.
- Bring you different perspectives of your sales in the period of time you set.