# Slide presentation

This slide will let you analyze macro information about the transactions and the items involved in these transactions.


:warning: **Diclaimer 1** : These charts are done **BEFORE both the transactions and the items are preprocessed in the [transactions_preprocessing](flow_zone:3La1CrK) zone**, based on the parameters you set in your application (Learn more about [the transactions preprocessing](article:50) or the [association rules computation](article:51)).

:warning: **Diclaimer 2** : On the pictures below, charts have been computed using the "Country" column as an *association rule scope* ([Learn more about this concept](article:51)). Your render will be different (aggregated views on *'all_data'*) if you don't define a rule scope.

![slide_2_overview.png](PdgR12shxPSX)

# Slide charts

## Total number of transactions

This chart shows the total number of transactions (with more than 1 distinct item and more than the minimum number of item you set) that are present before their preprocessing.
Transactions are colored differently if their number is above or below the *minimum amount of transaction* parameter you set. Transactions below this value are not kept for the association rules learning process.

![slide_2_total_number_of_transactions.png](9ZaSUemM6AtC)


## Items support analysis

The charts below are dedicated to analyze the average support of the items that are present before their preprocessing. They give different views of this support, from the less accurate (average support) to the more accurate (full univariate analysis of the support).

### Average items support

![slide_2_average_items_support.png](2CEBBHGiP1lA)

### Min, Average and Max items support

![slide_2_min_average_max_items_support.png](qAWLKO5ZTVW6)

### Items support univariate analysis

![slide_2_items_support_univariate_analysis.png](IPj6NLiZ7wwo)


# Leveraging these charts

Analyzing the number of transaction can help you to:
- Why you don't see some rule scopes in the final association rules.
- Understand why some items support are higher/lower depending on your rule scopes.

Analyzing the items descriptive statistics can help you to:
- Tune the items frequency threshold in your application in order to more easily find association rules.
- Understand why more rules are found on some rule scopes than on others.