# Slide presentation

This slide will let you analyze macro information about the transactions and the items involved in these transactions.


:warning: **Diclaimer 1** : These charts are done **AFTER both the transactions and the items are preprocessed in the [transactions_preprocessing](flow_zone:3La1CrK) zone**, based on the parameters you set in your application (Learn more about [the transactions preprocessing](article:50) or the [association rules computation](article:51)).

:warning: **Diclaimer 2** : On the pictures below, charts have been computed using the "Country" column as an *association rule scope* ([Learn more about this concept](article:51)). Your render will be different (aggregated views on *'all_data'*) if you don't define a rule scope.

![slide_3_overview.png](B1OfZ8meVpJ8)

# Slide charts

## Total number of transactions

This chart shows the total number of transactions (with more than 1 distinct item and more than the minimum number of item you set) that are present after their preprocessing.

![slide_3_total_number_of_transactions.png](jIQVwSOVZMWo)


## Items support analysis

The charts below are dedicated to analyze the average support of the items that are present after their preprocessing. They give different views of this support, from the less accurate (average support) to the more accurate (full univariate analysis of the support).

### Average items support

![slide_3_average_items_support.png](PjStBWPAffdl)

### Min, Average and Max items support

![slide_3_min_average_max_items_support.png](bpguPWdA3MZk)

### Items support univariate analysis

![slide_3_items_support_univariate_analysis.png](2w2C73JAZu2G)


# Leveraging these charts

Analyzing the number of transaction can help you to:
- Have an overview of the transactions taken into acount in your **Market Basket Analysis**.
- Understand why some items support are higher/lower depending on your rule scopes.

Analyzing the items descriptive statistics can help you to:
- Have an overview of the support distribution for your different items.
- Understand why more rules are found on some rule scopes than on others.