# Discipline definition
[Wikipedia's definition: ](https://en.wikipedia.org/wiki/Association_rule_learning) 
> **Association rule learning** is a rule-based machine learning method for discovering interesting relations between variables in large databases. It is intended to identify strong association rules discovered in databases using some measures of interestingness.

The Market Basket Analysis will extract rules based on the items ([learn more about items](article:20)) co-occurence frequencies within transactions.

# A case study
This wiki section will help you understand all the market basket analysis lingo through both theoretical concepts and their application, step by step, through a simple case study. It will consist in analyzing product sales in order to learn association rules between them ([See the association rule lingo](article:10)).

We will use data from a retailer selling 11 products : 
- Bacon.
- Cabbage.
- Chicken.
- Corn.
- Garlic.
- Tomato.
- Salad.
- Pepper.
- Onion.
- Tortilla.
- Mushroom.

![items.png](ICevR7uslMTm)

> All emojis designed by [OpenMoji](https://openmoji.org/) – the open-source emoji and icon project. License: [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/#).


