# From frequent patterns to rules

## Definition
Frequent patterns search is allowed by an ensemble of techniques helping in the identification of the most frequent patterns (or "co-occurences") of itemsets within a database. 
Once that frequent itemsets are identified, splitting it leads to generate association rules between antecedents and consequents.

## In practice

The association rules learning of the project works with the [FP-growth algorithm](https://en.wikipedia.org/wiki/Association_rule_learning#FP-growth_algorithm). 

## Regarding our case study

### Starting with the aggregated transactions table.

We will define the minimum support count as a hyperparameter of the algorithm :  **Min_support** (Also known as *Itemsets min frequency* in the [Association rules computation](article:51) section of the dataiku application). That hyperparameter will then allow the FP-growth to filter the most frequent itemsets occuring together.

![transactions_aggregated.png](AtBeDATBPeQ0)